/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-iai-robosherlock-actions-0.0.5-0raring-20150424-1746/obj-i686-linux-gnu/devel/share/iai_robosherlock_actions/msg/SimplePerceiveObjectAction.msg
 *
 */


#ifndef IAI_ROBOSHERLOCK_ACTIONS_MESSAGE_SIMPLEPERCEIVEOBJECTACTION_H
#define IAI_ROBOSHERLOCK_ACTIONS_MESSAGE_SIMPLEPERCEIVEOBJECTACTION_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <iai_robosherlock_actions/SimplePerceiveObjectActionGoal.h>
#include <iai_robosherlock_actions/SimplePerceiveObjectActionResult.h>
#include <iai_robosherlock_actions/SimplePerceiveObjectActionFeedback.h>

namespace iai_robosherlock_actions
{
template <class ContainerAllocator>
struct SimplePerceiveObjectAction_
{
  typedef SimplePerceiveObjectAction_<ContainerAllocator> Type;

  SimplePerceiveObjectAction_()
    : action_goal()
    , action_result()
    , action_feedback()  {
    }
  SimplePerceiveObjectAction_(const ContainerAllocator& _alloc)
    : action_goal(_alloc)
    , action_result(_alloc)
    , action_feedback(_alloc)  {
    }



   typedef  ::iai_robosherlock_actions::SimplePerceiveObjectActionGoal_<ContainerAllocator>  _action_goal_type;
  _action_goal_type action_goal;

   typedef  ::iai_robosherlock_actions::SimplePerceiveObjectActionResult_<ContainerAllocator>  _action_result_type;
  _action_result_type action_result;

   typedef  ::iai_robosherlock_actions::SimplePerceiveObjectActionFeedback_<ContainerAllocator>  _action_feedback_type;
  _action_feedback_type action_feedback;




  typedef boost::shared_ptr< ::iai_robosherlock_actions::SimplePerceiveObjectAction_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::iai_robosherlock_actions::SimplePerceiveObjectAction_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct SimplePerceiveObjectAction_

typedef ::iai_robosherlock_actions::SimplePerceiveObjectAction_<std::allocator<void> > SimplePerceiveObjectAction;

typedef boost::shared_ptr< ::iai_robosherlock_actions::SimplePerceiveObjectAction > SimplePerceiveObjectActionPtr;
typedef boost::shared_ptr< ::iai_robosherlock_actions::SimplePerceiveObjectAction const> SimplePerceiveObjectActionConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::iai_robosherlock_actions::SimplePerceiveObjectAction_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::iai_robosherlock_actions::SimplePerceiveObjectAction_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace iai_robosherlock_actions

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'shape_msgs': ['/opt/ros/hydro/share/shape_msgs/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'designator_integration_msgs': ['/opt/ros/hydro/share/designator_integration_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'iai_robosherlock_actions': ['/tmp/buildd/ros-hydro-iai-robosherlock-actions-0.0.5-0raring-20150424-1746/msg', '/tmp/buildd/ros-hydro-iai-robosherlock-actions-0.0.5-0raring-20150424-1746/obj-i686-linux-gnu/devel/share/iai_robosherlock_actions/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::iai_robosherlock_actions::SimplePerceiveObjectAction_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::iai_robosherlock_actions::SimplePerceiveObjectAction_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::iai_robosherlock_actions::SimplePerceiveObjectAction_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::iai_robosherlock_actions::SimplePerceiveObjectAction_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::iai_robosherlock_actions::SimplePerceiveObjectAction_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::iai_robosherlock_actions::SimplePerceiveObjectAction_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::iai_robosherlock_actions::SimplePerceiveObjectAction_<ContainerAllocator> >
{
  static const char* value()
  {
    return "a46535474ba4984ba700172ae1483282";
  }

  static const char* value(const ::iai_robosherlock_actions::SimplePerceiveObjectAction_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xa46535474ba4984bULL;
  static const uint64_t static_value2 = 0xa700172ae1483282ULL;
};

template<class ContainerAllocator>
struct DataType< ::iai_robosherlock_actions::SimplePerceiveObjectAction_<ContainerAllocator> >
{
  static const char* value()
  {
    return "iai_robosherlock_actions/SimplePerceiveObjectAction";
  }

  static const char* value(const ::iai_robosherlock_actions::SimplePerceiveObjectAction_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::iai_robosherlock_actions::SimplePerceiveObjectAction_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
\n\
SimplePerceiveObjectActionGoal action_goal\n\
SimplePerceiveObjectActionResult action_result\n\
SimplePerceiveObjectActionFeedback action_feedback\n\
\n\
================================================================================\n\
MSG: iai_robosherlock_actions/SimplePerceiveObjectActionGoal\n\
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
\n\
Header header\n\
actionlib_msgs/GoalID goal_id\n\
SimplePerceiveObjectGoal goal\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: actionlib_msgs/GoalID\n\
# The stamp should store the time at which this goal was requested.\n\
# It is used by an action server when it tries to preempt all\n\
# goals that were requested before a certain time\n\
time stamp\n\
\n\
# The id provides a way to associate feedback and\n\
# result message with specific goal requests. The id\n\
# specified must be unique.\n\
string id\n\
\n\
\n\
================================================================================\n\
MSG: iai_robosherlock_actions/SimplePerceiveObjectGoal\n\
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
# goal\n\
#\n\
# list of descriptions of the objects the client wants the\n\
# the perception system to look for\n\
designator_integration_msgs/Designator[] requests\n\
\n\
================================================================================\n\
MSG: designator_integration_msgs/Designator\n\
int32 TYPE_OBJECT=0\n\
int32 TYPE_ACTION=1\n\
int32 TYPE_LOCATION=2\n\
int32 TYPE_HUMAN=3\n\
\n\
int32 type\n\
\n\
KeyValuePair[] description\n\
\n\
================================================================================\n\
MSG: designator_integration_msgs/KeyValuePair\n\
# Purely for (de-)serialization purposes\n\
int32 id\n\
int32 parent\n\
\n\
# Data\n\
int32 TYPE_STRING=0\n\
int32 TYPE_FLOAT=1\n\
int32 TYPE_DATA=2\n\
int32 TYPE_LIST=3\n\
int32 TYPE_POSESTAMPED=4\n\
int32 TYPE_POSE=5\n\
int32 TYPE_DESIGNATOR_ACTION=6\n\
int32 TYPE_DESIGNATOR_OBJECT=7\n\
int32 TYPE_DESIGNATOR_LOCATION=8\n\
int32 TYPE_DESIGNATOR_HUMAN=9\n\
int32 TYPE_POINT=10\n\
int32 TYPE_WRENCH=11\n\
int32 TYPE_MATRIX=12\n\
int32 TYPE_VECTOR=13\n\
\n\
int32 type\n\
\n\
string key\n\
string value_string\n\
float64 value_float\n\
char[] value_data\n\
float64[] value_array\n\
geometry_msgs/PoseStamped value_posestamped\n\
geometry_msgs/Pose value_pose\n\
geometry_msgs/Point value_point\n\
geometry_msgs/Wrench value_wrench\n\
\n\
================================================================================\n\
MSG: geometry_msgs/PoseStamped\n\
# A Pose with reference coordinate frame and timestamp\n\
Header header\n\
Pose pose\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of postion and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Wrench\n\
# This represents force in free space, separated into\n\
# its linear and angular parts.\n\
Vector3  force\n\
Vector3  torque\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Vector3\n\
# This represents a vector in free space. \n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
================================================================================\n\
MSG: iai_robosherlock_actions/SimplePerceiveObjectActionResult\n\
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
\n\
Header header\n\
actionlib_msgs/GoalStatus status\n\
SimplePerceiveObjectResult result\n\
\n\
================================================================================\n\
MSG: actionlib_msgs/GoalStatus\n\
GoalID goal_id\n\
uint8 status\n\
uint8 PENDING         = 0   # The goal has yet to be processed by the action server\n\
uint8 ACTIVE          = 1   # The goal is currently being processed by the action server\n\
uint8 PREEMPTED       = 2   # The goal received a cancel request after it started executing\n\
                            #   and has since completed its execution (Terminal State)\n\
uint8 SUCCEEDED       = 3   # The goal was achieved successfully by the action server (Terminal State)\n\
uint8 ABORTED         = 4   # The goal was aborted during execution by the action server due\n\
                            #    to some failure (Terminal State)\n\
uint8 REJECTED        = 5   # The goal was rejected by the action server without being processed,\n\
                            #    because the goal was unattainable or invalid (Terminal State)\n\
uint8 PREEMPTING      = 6   # The goal received a cancel request after it started executing\n\
                            #    and has not yet completed execution\n\
uint8 RECALLING       = 7   # The goal received a cancel request before it started executing,\n\
                            #    but the action server has not yet confirmed that the goal is canceled\n\
uint8 RECALLED        = 8   # The goal received a cancel request before it started executing\n\
                            #    and was successfully cancelled (Terminal State)\n\
uint8 LOST            = 9   # An action client can determine that a goal is LOST. This should not be\n\
                            #    sent over the wire by an action server\n\
\n\
#Allow for the user to associate a string with GoalStatus for debugging\n\
string text\n\
\n\
\n\
================================================================================\n\
MSG: iai_robosherlock_actions/SimplePerceiveObjectResult\n\
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
# result\n\
#\n\
# upon termination or cancelation, the vision system sends back\n\
# a (potentially incomplete, in case of cancel) list of descriptions\n\
# of objects it has last seen\n\
designator_integration_msgs/Designator[] percepts\n\
\n\
================================================================================\n\
MSG: iai_robosherlock_actions/SimplePerceiveObjectActionFeedback\n\
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
\n\
Header header\n\
actionlib_msgs/GoalStatus status\n\
SimplePerceiveObjectFeedback feedback\n\
\n\
================================================================================\n\
MSG: iai_robosherlock_actions/SimplePerceiveObjectFeedback\n\
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
# feedback\n\
#\n\
# whenever the vision pipeline ran through, the vision system\n\
# reports a list of descriptions of the objects it has found\n\
designator_integration_msgs/Designator[] percepts\n\
\n\
";
  }

  static const char* value(const ::iai_robosherlock_actions::SimplePerceiveObjectAction_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::iai_robosherlock_actions::SimplePerceiveObjectAction_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.action_goal);
      stream.next(m.action_result);
      stream.next(m.action_feedback);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct SimplePerceiveObjectAction_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::iai_robosherlock_actions::SimplePerceiveObjectAction_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::iai_robosherlock_actions::SimplePerceiveObjectAction_<ContainerAllocator>& v)
  {
    s << indent << "action_goal: ";
    s << std::endl;
    Printer< ::iai_robosherlock_actions::SimplePerceiveObjectActionGoal_<ContainerAllocator> >::stream(s, indent + "  ", v.action_goal);
    s << indent << "action_result: ";
    s << std::endl;
    Printer< ::iai_robosherlock_actions::SimplePerceiveObjectActionResult_<ContainerAllocator> >::stream(s, indent + "  ", v.action_result);
    s << indent << "action_feedback: ";
    s << std::endl;
    Printer< ::iai_robosherlock_actions::SimplePerceiveObjectActionFeedback_<ContainerAllocator> >::stream(s, indent + "  ", v.action_feedback);
  }
};

} // namespace message_operations
} // namespace ros

#endif // IAI_ROBOSHERLOCK_ACTIONS_MESSAGE_SIMPLEPERCEIVEOBJECTACTION_H
